<template lang="pug">
  main-layout
    template(v-slot:header="")
      header-block

    template(v-slot:content="")
      .b-content
        .b-content__title Добавление нового пользователя
          v-container(
            align-content-center
            grid-list-md
          )
            v-layout(row wrap justify-space-around)
              v-flex(xs12 lg4 sm6 md6 d-flex)
                v-select(
                  v-model="role"
                  :items="roles"
                  item-text="name"
                  item-value="role"
                  label="Выберите роль пользователя"
                  :menu-props="menuProps"
                  outline
                )
            v-layout(row wrap justify-space-around)
              v-flex(xs12 lg4 sm6 md6 d-flex)
                v-text-field(
                  v-model="loginUser"
                  label="Введите email пользователя"
                  :error-messages="loginUserErrors"
                  required
                  outline
                  @input="$v.loginUser.$touch()"
                  @blur="$v.loginUser.$touch()"
                )

            v-layout(row wrap justify-space-around)
              v-flex(xs12 lg4 sm6 md6 d-flex)
                v-text-field(
                  v-model="passwordUser"
                  type="password"
                  label="Введите пароль пользователя"
                  :error-messages="passwordUserErrors"
                  required
                  outline
                  @input="$v.passwordUser.$touch()"
                  @blur="$v.passwordUser.$touch()"
                )

            v-layout(row wrap justify-space-around)
              v-flex(xs12 lg4 sm6 md6 d-flex)
                v-text-field(
                  v-model="repeatPassword"
                  type="password"
                  label="Повторите пароль пользователя"
                  :error-messages="repeatPasswordErrors"
                  required
                  outline
                  @input="$v.repeatPassword.$touch()"
                  @blur="$v.repeatPassword.$touch()"
                )

            .b-login__row.b-login__row--center
              button-field(
                :clickAction="addUsers"
              )
                | Добавить

    template(v-slot:footer="")
      footer-block
</template>

<script>
import { required, email, minLength, sameAs } from 'vuelidate/lib/validators';
import HeaderBlock from '../components/header/index.vue';
import FooterBlock from '../components/footer/index.vue';
import MainLayout from '../components/layout/index.vue';
import ButtonField from '../components/button/index.vue';

export default {
  name: 'Admin',
  components: {
    HeaderBlock,
    FooterBlock,
    MainLayout,
    ButtonField,
  },
  data() {
    return {
      roles: [
        {
          role: 1,
          name: 'пользователь',
        },
        {
          role: 2,
          name: 'администратор',
        },
      ],
      menuProps: {
        absolute: false,
      },
      repeatPassword: '',
    };
  },
  validations: {
    loginUser: { required, email },
    passwordUser: { required, minLength: minLength(5) },
    repeatPassword: { required, sameAsPassword: sameAs('passwordUser') },
  },
  computed: {
    role: {
      get() {return this.$store.getters['admin/getRoleIdUser']},
      set(value) {
        this.$store.commit('admin/setRoleIdUser', value);
      },
    },
    loginUser: {
      get() {return this.$store.getters['admin/getLoginUser']},
      set(value) {
        this.$store.commit('admin/setLoginUser', value);
      },
    },
    passwordUser: {
      get() {return this.$store.getters['admin/getPasswordUser']},
      set(value) {
        this.$store.commit('admin/setPasswordUser', value);
      },
    },
    loginUserErrors() {
      const errors = [];
      if (!this.$v.loginUser.$dirty) return errors;
      if (!this.$v.loginUser.required) {
        errors.push('Обязательно для заполнения.');
      }
      if (!this.$v.loginUser.email) {
        errors.push('Email не верен.');
      }
      return errors;
    },
    passwordUserErrors() {
      const errors = [];
      if (!this.$v.passwordUser.$dirty) return errors;
      if (!this.$v.passwordUser.required) {
        errors.push('Обязательно для заполнения.');
      }
      if (!this.$v.passwordUser.minLength) {
        errors.push('Пароль должен быть не менее 5 символов')
      }
      return errors;
    },
    repeatPasswordErrors() {
      const errors = [];
      if (!this.$v.repeatPassword.$dirty) return errors;
      if (!this.$v.repeatPassword.required) {
        errors.push('Обязательно для заполнения.');
      }
      if (!this.$v.repeatPassword.sameAsPassword) {
        errors.push('Пароль введен не верно.');
      }
      return errors;
    },
  },
  methods: {
    addUsers() {
      this.$v.$touch();

      if (!this.$v.$invalid) {
        this.$store.dispatch('admin/addUser')
          .then(() => {
            this.$notify({
              group: 'note',
              type: 'info',
              title: 'Пользователь добавлен',
              text: '',
            });

            this.repeatPassword = '';
            this.$store.commit('admin/resetDataAddUser');
            this.$v.$reset();
          })
          .catch(() => {
            this.$notify({
              group: 'note',
              type: 'error',
              title: 'Ошибка',
              text: 'Пользователь не добавлен.',
            });
          });
      }
    },
  }
};
</script>
